use regex::Regex;
use std::fs;

pub fn solve() {
    let path = "res/03/input";

    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let mults = get_mults(contents.as_str());

    let result = mults.iter().map(|(a, b)| a * b).sum::<usize>();

    println!("Result 1: {}", result);

    let contents = contents.split("don't()").collect::<Vec<&str>>();

    let mut do_contents = contents
        .iter()
        .skip(1)
        .map(|c| c.split_once("do()").unwrap_or(("", "")).1)
        .collect::<Vec<&str>>()
        .join("");

    do_contents += contents[0];

    let mults = get_mults(do_contents.as_str());

    let result = mults.iter().map(|(a, b)| a * b).sum::<usize>();

    println!("Result 2: {}", result);
}

fn get_mults(contents: &str) -> Vec<(usize, usize)> {
    let re = Regex::new(r"mul\((\d{1,3}),(\d{1,3})\)").unwrap();
    re.find_iter(contents)
        .map(|m| {
            m.as_str()
                .trim_start_matches("mul(")
                .trim_end_matches(')')
                .split_once(',')
                .map(|(s1, s2)| (s1.parse::<usize>().unwrap(), s2.parse::<usize>().unwrap()))
                .unwrap()
        })
        .collect::<Vec<(usize, usize)>>()
}
