use std::fs;

pub fn solve() {
    let path = "res/04/input";

    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let grid = contents
        .lines()
        .map(|l| l.chars().collect::<Vec<char>>())
        .collect::<Vec<Vec<char>>>();

    // add rows
    let mut strings = grid
        .iter()
        .map(|l| l.iter().collect::<String>())
        .collect::<Vec<String>>();

    // add cols
    for i in 0..grid.len() {
        let col = grid.iter().map(|l| l[i]).collect::<Vec<char>>();
        strings.push(col.iter().collect::<String>());
    }

    // add diagonals
    for i in 0..grid.len() {
        let mut diag: Vec<Vec<char>> = vec![vec!(); 4];

        // left-to-right
        for j in 0..grid.len() {
            if i + j < grid.len() && j < grid[0].len() {
                diag[0].push(grid[i + j][j])
            }
            if i >= j && j < grid[0].len() {
                diag[1].push(grid[i - j][j])
            }
        }

        for j in 0..grid.len() {
            if i + j < grid.len() && j > 0 && j <= grid[0].len() {
                diag[2].push(grid[i + j][grid[0].len() - j])
            }
            if i >= j && j > 0 && j <= grid[0].len() {
                diag[3].push(grid[i - j][grid[0].len() - j])
            }
        }

        strings.append(
            &mut diag
                .iter()
                .map(|l| l.iter().collect::<String>())
                .collect::<Vec<String>>(),
        );
    }

    let result: usize = strings
        .iter()
        .map(|s| {
            s.matches("XMAS").count() + s.chars().rev().collect::<String>().matches("XMAS").count()
        })
        .sum();

    println!("Result 1: {}", result);

    let result: usize = grid
        .windows(3)
        .map(|rows| {
            let mut count = 0;
            for i in 0..rows[0].len() - 2 {
                let str1 = format!("{}{}{}", rows[0][i], rows[1][i + 1], rows[2][i + 2]);
                let str2 = format!("{}{}{}", rows[0][i + 2], rows[1][i + 1], rows[2][i]);
                if (str1 == "MAS" || str1 == "SAM") && (str2 == "MAS" || str2 == "SAM") {
                    count += 1;
                }
            }
            count
        })
        .sum();

    println!("Result 2: {}", result);
}
